#ifndef SYNCHRONIZE_H_
#define SYNCHRONIZE_H_

#include <semaphore.h>
#include <pthread.h>
#include "globals.h"

// Mutex functions
sem_t *INIT(Mutex *mutex, char *name);
sem_t *USE(Mutex *mutex, char *name);
void LOCK(Mutex *mutex);
void UNLOCK(Mutex *mutex);

// Semaphore functions
void REMOVE(char *name);
sem_t *CREATE(Semaphore *semaphore, char *name, int value);
sem_t *OPEN(Semaphore *semaphore, char *name);
void WAIT(Semaphore *semaphore);
void SIGNAL(Semaphore *semaphore);

#endif /* SYNCHRONIZE_H_ */
